/***************************************************
 *                                                 *
 *    Macro Assembler            		   *
 *						   *
 *    Copyright 1989    Richard P. Cornwell        *
 *    Developmental Code not for redistubution     *
 *                                                 *
 *    Written by Richard Cornwell                  *
 *               10/2/85                           *
 *                                                 *
 ***************************************************/

#include "macro.h"
#ifdef MACASM
char *macptr[MACNEST];
struct mac *macdef[MACNEST];
struct text *global;
struct text *macsym[MACNEST];
struct mac *mactab = NULL;
char indname[] = "sysindx";
int sysindx;
int macpos[MACNEST];
int maclvl, macnest;
int mactype[MACNEST];


addline() {
   int i;
   char *p;

   i = strlen(line);	/* Get length */
   /* reallocate the block bigger */
   macptr[macnest] = (char *)realloc(macptr[macnest],macpos[macnest]+i+1);
   if(macptr[macnest] == NULL) fatal("Out of macro space", 0);
   strcat(macptr[macnest], line);  /* Copy on end */
   macpos[macnest] += i;
   }

expand() {
   int i, j;
   char c, word[NCPS];
   char *temp;

   position = 0;
   i=0;
   if(pass == 2) {
	i = linnum;			/* Don't let line number get */
	readline();			/* touched by readline */
	linnum = i;
	return;
	}
   while((c=macget()) != '\0')
    { if(c=='\n') break;		/* End of line ? */
      else if(c=='&'&& macpeek() == '&') line[i++] = macget();	/* && = & */
      else if(c=='&') {			/* Not && must be variable */
         j=0;
         c=macpeek();			/* Collect in word */
	 while((c>='a' && c<='z') || (c>='A' && c<='Z') || (c>='0' && c<='9')) {
           c=macget();
           word[j++] = c;
           c=macpeek();
           }
         word[j++] = '\0';		/* Go look it up */
         if((temp = maclook(word))==NULL) {
		line[i++] = '&';
		for(j=0; word[j]; line[i++] = word[j++]);
		}
         else   for(j=0; temp[j]; line[i++] = temp[j++]);
         if(c=='.') c = macget();	/* Ends in &x. = x */
         }
      else line[i++] = c;
      }
      line[i++] = '\n';
      line[i++] = '\0';
      prlflag |= 1;
      for(i=0; line[i]; i++)
	 { prline[START+i] = line[i];		/* Print it */
	   putc(line[i],wrkfil);		/* Save to workfile */
	 }
      putc(maclvl,wrkfil);		/* Save maclvl */
#ifdef MAXCOND
      putc(condval[currlvl], wrkfil);	/* Save cond flag */
#endif
      prline[START+i] = '\0';
     }

char macget() {
    char c;

    c = *(macptr[macnest]++);
    if(macpos[macnest]-- == 0) {
    	macptr[macnest]--;
	macpos[macnest]++;
	}
    return(c);
    }

char macpeek() {

    if(macpos[macnest] == 0) return('\0');
    else		  return(*macptr[macnest]);
    }

char *maclook(s) char *s; 
{  int i;
   struct text *p;

   for(i=macnest; i>=0; i--)
   { p = macsym[i];
     while(p!= NULL) {
       if(p->name != NULL && strcmp(s,p->name)==0) break;
       else p = p->ptr;
       }
     if(p!=NULL) break;
     }
   if(p==NULL) return(NULL);
   
#ifdef DEBUG
fprintf(stderr,"%s -> %s\n",s,p->data);
#endif
   return(p->data);
   }

macset(n,v) char *n,*v;
{
   char *p;
   int i, j;
   if((p = maclook(n))== NULL) return(0);
   i = strlen(v)+1;		/* truncate at TXTSIZE */
   if((i) >= TXTSIZE) v[TXTSIZE]= '\0';  /* Truncate it */
   strcpy(p,v);
 }

maclcl() {
   int i,j;
   struct text *x;
   char *name;
 
   for(x = macsym[macnest]; x->ptr != NULL; x = x->ptr);
   oprand[strlen(oprand)+2] = '\0';
   for(i=0; oprand[i] == ' ' || oprand[i] == '\t'; i++);
   j = 0;
   do { 
	if(j != 0 && ((oprand[i] == ' ') || (oprand[i] == ',')
	            || (oprand[i] == '\n') || (oprand[i] == '\0'))) {
	    oprand[i] = '\0';
	    if((x->ptr = (struct text *)calloc(1,sizeof(struct text))) == NULL)
              fatal("Out of macro space",0);
	    stor += sizeof(struct text);
	    x->ptr = NULL;
	    if((x->name = (char *)calloc(1,strlen(name)+1)) == NULL)
		fatal("Out of macro space",0);
	    strcpy(x->name, name);
	    x->data[0] = '\0';
	    j = 0;
	    i++;
	    }
	else if(j == 0 && (oprand[i] != ' ' || oprand[i] != ','
	     || oprand[i] != '\n' || oprand[i] != '\0')) {
	     name = &oprand[i];
	     j++;
	     }
    } while( oprand[i++] != '\0');
  }

macglb() {
   int i,j;
   struct text *x;
   char *name;
 
   for(x = macsym[0]; x->ptr != NULL; x = x->ptr);
   oprand[strlen(oprand)+2] = '\0';
   for(i=0; oprand[i] == ' ' || oprand[i] == '\t'; i++);
   j = 0;
   do { 
	if(j != 0 && ((oprand[i] == ' ') || (oprand[i] == ',')
	            || (oprand[i] == '\n') || (oprand[i] == '\0'))) {
	    oprand[i] = '\0';
	    if((x->ptr = (struct text *)calloc(1,sizeof(struct text))) == NULL)
              fatal("Out of macro space",0);
	    stor += sizeof(struct text);
	    x->ptr = NULL;
	    if((x->name = (char *)calloc(1,strlen(name)+1)) == NULL)
		fatal("Out of macro space",0);
	    strcpy(x->name,name);
	    x->data[0] = '\0';
	    j=0;
	    i++;
	    }
	else if(j == 0 && (oprand[i] != ' ' || oprand[i] != ','
	     || oprand[i] != '\n' || oprand[i] != '\0')) {
	     	name = &oprand[i];
		j++;
		}
    } while( oprand[i++] != '\0');
  }

macgo(n) char *n;
{
   int i,f;
   char c;
   char name[TXTSIZE];

   macptr[macnest] = macdef[macnest]->def;
   macpos[macnest] = strlen(macptr[macnest]);
   f = 0;
   while((c=macget()) != '\0' ) {
      if(c=='\n') f=i=0;
      else if(c=='.' && f==0) f=1;
      else if(f==1 && n[i] == c)
	if(n[++i] == '\0') break;
      else f=i= -1;
      }
    if(c=='\0') error('l');
    else macget(); /* skip nl */
   }

macbuild(m)  struct mac *m;
{   struct text *x,*y;
    char *name; 
    char *p;
    char buff[TXTSIZE];
    int state;
    int i,j,k;

#ifdef DEBUG
    fprintf(stderr,"building: %s nest = %d\n",m->name, macnest);
#endif
    maclvl = 2;
    if(pass == 2)	return;			/* On pass 2 just return */
    macnest++;					/* Increment Nesting */
    if(macnest>=MACNEST) error('n');
    macpos[macnest] = strlen(m->def);			/* Setup pointers */
    macptr[macnest] = m->def;
    macdef[macnest] = m;
    p = m->sym; 				/* Make symbol table */
    if((x = (struct text *)calloc(1,sizeof(struct text))) == NULL) 
	fatal("Out of macro space",0);
    stor += sizeof(struct text);
    if((x->name = (char *)calloc(1,sizeof(indname)+1)) == NULL)
	fatal("Out of macro space",0);
	/* First is &sysindex = index */
    macsym[macnest] = x;
    strcpy(x->name, indname);
    for(i=3, j= ++sysindx; i >= 0; i--, j/= 10)  x->data[i] = j%10 + '0';
	/* Space for &name = label */
    if((x = (struct text *)calloc(1,sizeof(struct text))) == NULL)
	fatal("Out of macro space",0);
    stor += sizeof(struct text);
    macsym[macnest]->ptr = x;
    x->ptr = NULL;
    i = 0;
    j = 0;
    k = 0;
	/* Load defaults */
    while(*p) {	
	if(*p == '\n' || *p == '=') {	/* End on one name */
	    x->data[j++] = '\0'; 	/* Mark end */
	    if((x->name = (char *)calloc(1,j)) == NULL)
		fatal("Out of macro space",0);
	    strcpy(x->name, x->data);	/* Copy name */
	    if(*p == '=') p++;		/* Skip = */
	    for(j=0; *p != '\n' && *p != '\0'; j++) /* Copy default */
		x->data[j] = *p++;
	    x->data[j++] = '\0'; 		/* Make another */
	    if(*++p == '\0') break;			/* Leave now */
	    if((y=(struct text *)calloc(1,sizeof(struct text))) == NULL) 
		fatal("Out of macro space",0);
	    stor += sizeof(struct text);
	    x->ptr = y;
	    y->ptr = NULL;
	    x = y;
	    j = 0;
	}
        x->data[j++] = *p++;	/* Copy name */
     }
     if(labfld)  strcpy(macsym[macnest]->ptr->data,labfld);
     x = macsym[macnest]->ptr;		/* Define name */ 
     i=0;
     x = x->ptr;			/* Chain down list */
     state = 0;
     j = 0; 
     k = 0;
     for(i=0; oprand[i] == '\t' || oprand[i] == ' '; i++);
     do {
	if(((oprand[i] == ',') | (oprand[i] == '\n') | (oprand[i] == '\0')) 
	    && ((state&1) == 0)) { 
	    if(state&2) {
		for(x=macsym[macnest]; x != NULL; x = x->ptr)
		    if(strcmp(name,x->name)==0) break;
	    }
	    if(j>= TXTSIZE) j=TXTSIZE-1;
	    buff[j] = '\0';
	    if(buff[0] != '\0')	strcpy(x->data,buff);
	    x = x->ptr;
	    j = 0;
	    state = 0;
	    }
	else if(oprand[i] == '"' || oprand[i] == '\'') {
	    buff[j++] = oprand[i];
	    if(j>= TXTSIZE) j=TXTSIZE;
	    state ^= 1;
	}
	else if(oprand[i] == '=' && state == 0) {
	    oprand[i] = '\0';
	    j = 0;
	    state = 2;
	    }
	else {
	    if((state&2) == 0 && j == 0) name = &oprand[i];
	    buff[j++] = oprand[i];
	    if(j>= TXTSIZE) j=TXTSIZE;
	    }
	} while (oprand[i++] != '\0');
#ifdef DEBUG
    for(x=macsym[macnest]; x!=NULL; x = x->ptr)
	fprintf(stderr,"set: %s -> %s\n",x->name,x->data);
#endif

    }


macadd() { 
    struct mac *p;
    char *t,c;
    int i,j,k;
    char *word;

    macnest ++; 
    if(pass==2) { maclvl = 4; return; }		/* ignore in pass 2 */
    if(maclvl == 0) maclvl = 1;
    mactype[macnest] = MACRO;
#ifdef DEBUG
    fprintf(stderr,"macadd: line = %s\n",oprand);
#endif
    oprand[strlen(oprand)+2] = '\0';			/* Double terminator */
    for(i=0; oprand[i] == ' ' || oprand[i] == '\t'; i++);	/* skip */
    j = i;
    for(j=0; oprand[i] != ',' && oprand[i] != '\n' 
          && oprand[i] != '\0' && oprand[i] != ' ' && oprand[i] != '\t'; i++); 
    	/* Copy name */
    word = (char *) alloca(i-j+1);			/* Temp on stack */
    strncpy(word, &oprand[j], i-j);			/* Copy it */
    word[i-j] = '\0';
    if(word[0] == '\0') { error('d'); maclvl = 0; return; }	/* Any ? */
    if((p=macfind(word)) != NULL)  error('r');			/* find it */
    p = macent(word);						/* Add it */

	/* Scan arguments */ 
    if((t = (char *)malloc(sizeof(line))) == NULL)	/* Size of line */
	fatal("Out of macro space", 0);
    j = 0;
    *t = '\0';
    if(labfld) {					/* Add label */
	strcpy(t, labfld);
	strcat(t, "=");
	j = strlen(t);
	}
    else j = 0;
    t[j++] = '\n';
    k=0;			/* Now params */
    do { 
	 if(oprand[i] == ',') { i++; break; } 
         if(oprand[i] != ' ' && oprand[i] == '\t') break;
	} while(oprand[i++] != '\0');
    do { 
#ifdef DEBUG
fprintf(stderr,"%c",oprand[i]);
#endif
	  if(oprand[i] == ',' || oprand[i] == '\n' || oprand[i] == '\0') { 
	     if(k==0)  t[j++] = '=';
	     k=0;
	     t[j++] = '\n';
	    }
	else {
	    if(((k==0) & ((oprand[i] != ' ') | (oprand[i] != '\t'))) || k==1) { 
		t[j++] = oprand[i];
		if(oprand[i] == '=') k=1;
	     }
	  }
	} while(oprand[i++] != '\0');
      t[j++] = '\0';
      if((t = (char *)realloc(t, j)) == NULL)			/* Free space */
	fatal("Out of macro space ",0);
      p->sym = t;					/* Save pointer */
	/* Allocate a null definition */
      if((p->def = (char *)calloc(1,1)) == NULL)
	fatal("Out of macro space ", 0);
      macdef[macnest] = p;
      macptr[macnest] = p->def;
      macpos[macnest] = 0;
      }

struct mac *macfind(n) char *n; 
{   struct mac *p;
    int d;
    
    p = mactab;
    while(p!= NULL) { 
	if((d=strcmp(p->name,n))==0 )  return(p);
        if(d<0) p = p->llink;
	else    p = p->rlink;
	}
    return(NULL);
    }

struct mac *macent(n) char *n;
{   struct mac *p,*l;
    int d;
    p=mactab; 
    while(p!=NULL) {
	if((d=strcmp(p->name,n))==0) break;
 	l = p;
	if(d<0) p = p->llink;
	else 	p = p->rlink;
	}
    if((p=(struct mac *) malloc(sizeof(struct mac))) == NULL)
	fatal("Out of macro space",0);
    stor += sizeof(struct mac);
    if(mactab == NULL) mactab = p;
    else if(d<0) l->llink = p;
    else 	 l->rlink = p;
    d = strlen(n)+1;
    if((p->name = (char *)malloc(d)) == NULL)
	fatal("Out of macro space", 0);
    stor += d;
    strcpy(p->name, n);
    p->llink = NULL;
    p->rlink = NULL;
    p->def   = NULL;
    p->sym   = NULL;
    return(p);
    }


macend() {
    struct text *p, *q;

    switch(maclvl) {
	case 0:  error('M');
		 break;
	case 1:  if(pass ==1 )macdef[macnest]->def = macptr[macnest];
		 if(--macnest==0) maclvl = 0;
		 break;
	case 2:  if(pass == 2) break;		/* No expansion */
		 p = macsym[macnest];
		 while(p!=NULL) { 
		     q = p->ptr;
		     free(p->name);
		     free((char *)p);
		     stor -= sizeof(struct text);
		     p = q;
		 }
	case 4:	 if(--macnest==0) maclvl = 0;
		 break;
	}
}

getline() {
   struct opcodes *ptr;
   do {
    switch(maclvl) {
        case 0:	prlflag &= ~1;		/* Clear listing flag */
 		readline();
		return;
	case 1: 		/* Clear listing flag */
		readline();
		if(pass == 1)	addline(); /* Only define in pass 1 */
		scan();
		position = 0;
		printit();
		if(opcfld && (ptr=oplook(opcfld)) != NULL) {
		   if(ptr->type == MEND || ptr->type == MACRO) return;
		  }
                continue;
	case 2: expand();	/* Proccess macro */
		return;
	case 4: readline();
		scan();
		position = 0;
		printit();
                if(opcfld && (ptr=oplook(opcfld)) != NULL) {
		   if(ptr->type == MEND || ptr->type == MACRO) return;
		  }
		continue;
	}
    } while(maclvl==1 || maclvl==4); 
}
#endif
