
/***************************************************
 *                                                 *
 *    Macro Assembler			           *
 *                                                 *
 *    Copyright 1989    Richard P. Cornwell        *
 *    Developmental Code not for redistubution     *
 *                                                 *
 *    Written by Richard Cornwell                  *
 *               3/20/86                           *
 *                                                 *
 ***************************************************/

#include "macro.h"


unsigned long stkval[20];
struct symbol *stksym[20];
int	      oldlex[20];

int sp, oldptr;

int expr(p)
register struct ex *p;
{ register int x;

	sp = 0;
	oldptr = -1;
	x = orop();
	p->val = stkval[0];
	p->sym = stksym[0];
	switch(x) {
	default:
		error('X');
		return(-1);
	case -1:
		return(0);
	case EOL:
		return(1);
	case COMMA:
		return(2);
	}
}


int orop() {
register int x;

	x = xorop();
	while(x == OR) {
		sp++;
		x = xorop();
		eval(OR);
		}
	return(x);
}

int xorop() {
register int x;

	x = andop();
	while(x == XOR) {
		sp++;
		x = andop();
		eval(XOR);
		}
	return(x);
}

int andop() {
register int x;

	x = cmpop();
	while(x == AND) {
		sp++;
		x = cmpop();
		eval(AND);
		}
	return(x);
}

int cmpop() {
register int x, y;

	x = shfop();
	while(x >= LE && x <= GE) {
		sp++;
		y = shfop();
		eval(x);
		x = y;
	}
	return(x);
}

int shfop() {
register int x,y;

	x = addop();
	while(x == SHR || x == SHL) {
		sp++;
		y = addop();
		eval(x);
		x = y;
		}
	return(x);
}

int addop() {
register int x, y;

	x = mulop();
	while(x == PLUS || x == MINUS) {
		sp++;
		y = mulop();
		eval(x);
		x = y;
		}
	return(x);
}

int mulop() {
register int x,y;

	x = value();
	while(x == TIMES || x == DIVIDE || x == MOD) {
		sp++;
		y = value();
		eval(x);
		x = y;
		}
	return(x);
}


void
eval(op) int op;
{
	switch(op) {
		case PLUS: {
			register struct symbol *a, *b;

			stkval[sp-1] += stkval[sp];
			b = stksym[sp--];
			a = stksym[sp];
			if((a->flag) == (N_EXT|N_UNDF)) stksym[sp] = a;
			else if((b->flag) == (N_EXT|N_UNDF)) stksym[sp] = b;
			else if((a->flag) ==N_UNDF || (b->flag) == N_UNDF) 
					stksym[sp] = P_UNDF;
			else if((a->flag&N_TYPE)==N_ABS) stksym[sp] = b;
			else if((b->flag&N_TYPE)==N_ABS) stksym[sp] = a;
			else if(a->flag==b->flag) stksym[sp] = a;
			else stksym[sp] = P_UNDF;
			return;
			}
		case MINUS: {
			register struct symbol *a, *b;

			stkval[sp-1] -= stkval[sp];
			b = stksym[sp--];
			a = stksym[sp];
			if(a->flag==b->flag) stksym[sp] = P_ABS;
		 	else if((a->flag&N_TYPE)==N_ABS) stksym[sp] = b;
			else if((b->flag&N_TYPE)==N_ABS) stksym[sp] = a;
			else stksym[sp] = P_ABS;
			return;
			}
	case OR:	stkval[sp-1] |= stkval[sp];
			break;
	case XOR:	stkval[sp-1] ^= stkval[sp];
			break;
	case AND:	stkval[sp-1] &= stkval[sp];
			break;
	case EQ:	stkval[sp-1] = stkval[sp-1]==stkval[sp];
			break;
	case NE:	stkval[sp-1] = stkval[sp-1]!=stkval[sp];
			break;
	case LT:	stkval[sp-1] = stkval[sp-1] < stkval[sp];
			break;
	case GT:	stkval[sp-1] = stkval[sp-1] > stkval[sp];
			break;
	case LE:	stkval[sp-1] = stkval[sp-1]<=stkval[sp];
			break;
	case GE:	stkval[sp-1] = stkval[sp-1]>=stkval[sp];
			break;
	case SHR:	stkval[sp-1] = stkval[sp-1] >> stkval[sp];
			break;
	case SHL:	stkval[sp-1] = stkval[sp-1] << stkval[sp];
			break;
	case TIMES:	stkval[sp-1] *= stkval[sp];
			break;
	case DIVIDE:	stkval[sp-1] /= stkval[sp];
			break;
	case MOD:	stkval[sp-1] %= stkval[sp];
			break;
	}
	stksym[sp-1] = (stksym[sp-1]->flag==N_UNDF ||
			stksym[sp]->flag==N_UNDF) ?P_UNDF:P_ABS;
	sp--;
}

int value() {
register int x;

	x = lex();
	switch(x) {
	case MINUS:
		x = value();
		stkval[sp] = -stkval[sp];
		stksym[sp] = (stksym[sp]->flag==N_UNDF)?P_UNDF:P_ABS;
		return(x);
	case NOT:
		x = value();
		stkval[sp] = ~stkval[sp];
		stksym[sp] = (stksym[sp]->flag==N_UNDF)?P_UNDF:P_ABS;
		return(x);
	case RPARN:
		if(orop() != LPARN) return(-2);
	case NUMBER:
		return(lex());
	case EOL:
		return(-1);
	default:
		return(x);
	}
}
	

unlex(x) int x;
{
	oldlex[++oldptr] = x;
}


lex()		/* lexical analysis */
{ register char c;
  float fv;
  register unsigned long int v;
  char buffer[50];
  register int i;
	if(oldptr >= 0)
		return(oldlex[oldptr--]);
	while(c=oprand[pos++]) { if(c!=' ' && c!='\t') break; }
	switch(c) {
		case '\0':
		case LINSEP:
		case COMMENT:
		case '\n':	pos--;
				return(EOL);
		case '@':	return(AT);
		case '(':	return(RPARN);
		case ')':	return(LPARN);
		case '[':	return(RBRACE);
		case ']':	return(LBRACE);
		case ',':	return(COMMA);
		case '+':	return(PLUS);
		case '-':	return(MINUS);
		case '*':	return(TIMES);
		case '#':	return(NUM);
		case '$':	return(DOLLAR);
		case '/':	return(DIVIDE);
		case '%':	return(MOD);
		case ':':	return(COLON);
		case '<':	if(oprand[pos++] == '<') return(SHR);
	        		else if(oprand[pos] == '=') return(LE);
	        		else if(oprand[pos] == '>') return(NE);
	        		else { pos--; return(LT); }
		case '>':	if(oprand[pos++] == '>') return(SHL);
	        		else if(oprand[pos] == '=') return(GE);
	        		else { pos--; return(GT); }
		case '&':	return(AND);
		case '|':	return(OR);
		case '^':	return(XOR);
		case '~':	return(NOT);
		case '.':
#ifdef MC68000
				if(oprand[pos] == 'w' || oprand[pos] == 'l'
				 ||oprand[pos] == 'W' || oprand[pos] == 'L') {
					i = (oprand[pos] == 'l') |
					    (oprand[pos] == 'L');
					pos++;
					return(i?SIZEL:SIZEW);
					}
#endif
				stkval[sp] = location;
				stksym[sp] = &sects[section>>1];
				return(NUMBER);
		case '=':	return(EQ);
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': { register int flag, base;
				i=1;
				buffer[0] = c-'0';
				base = (c == '0')? 8: 10;
				if(oprand[pos] == 'x' ||
				   oprand[pos] == 'X') {
					base = 16; pos++; }
				flag = 0;
				while(c=oprand[pos++]) {
					if(c>='0' && c<='9') 
						buffer[i++] = c - '0';
					else if(c>='A' && c<='F') 
						{ buffer[i++] = (c-'A')+10;
						  base = 16; }
					else if(c>='a' && c<='f')
						{ buffer[i++] = (c-'a')+10;
						  base = 16; }
					else if(c=='H' || c=='h')
						{ base = 16; break; }
#ifdef MC68000
					else if(c=='.' ) {
						if(oprand[pos] == 'w' ||
						   oprand[pos] == 'l') {
							pos--;
							break;
						} else {
							base = 10;
							buffer[i++] = c;
							flag = 1;
						}
					}
#else
					else if(c=='.' ) {
						base = 10;
						buffer[i++] = c;
						flag = 1;
						}
#endif
					else if(flag && c=='e' || c== 'E') {
						buffer[i++] = 'E';
						buffer[i++] = oprand[pos++];
						}
					else { pos--; break; }
					}
				buffer[i++] = '\377';
#ifndef NOFLOAT
				if(flag) { double v,power;
					   register int exp,esign;

					for(v=0,i=0;
					  buffer[i]>=0 && buffer[i]<=9; i++)
						v = 10 * v + buffer[i];
					if(buffer[i++] != '.' )
						error('N');
					if(buffer[i] == '\377') {
						stkval[sp] = (int) v;
						stksym[sp] = P_ABS;
						return(NUMBER);
						}
					for(power=1;
					   buffer[i]>=0 && buffer[i]<=9; i++) {
					 	v = 10 * v + buffer[i];
						power *= 10;
						}
					if(buffer[i++] != '\377') {
						esign=0;
						if(buffer[i] == '-') {
							esign = 1;
							i++;
							}
					else if(buffer[i] == '+') { i++; }
					for(exp=0;
					  buffer[i]>=0 && buffer[i]<=9; i++)
					exp = 10*exp + buffer[i];
					for(; exp >= 0 ; exp--)
					   power = power * ((esign) ? 0.1 : 10);
					}
				stkval[sp] = (float) (v / power );
				stksym[sp] = P_ABS;
				return(NUMBER);
				}
			else 
#endif
			{
				for(i=0, v =0L;
					buffer[i]!='\377'&& buffer[i]!='.'; i++)
					v = v*(long)base + (long)buffer[i];
				stkval[sp] = v;
				stksym[sp] = P_ABS;
				return(NUMBER);
				}
			}
		case '\'' :
			stkval[sp] = 0L;
			while(oprand[pos] != '\'') {
				stkval[sp] <<= 8;
				stkval[sp] |= oprand[pos];
				if(oprand[++pos]=='\'' && oprand[pos+1]=='\'') {
					stkval[sp] <<= 8;
					stkval[sp] |= oprand[pos++];
					pos++;
					}
				}
			stksym[sp] = P_ABS;
			pos++;
			return(NUMBER);
		default:
	         { register struct symbol *p;
			if((c>='a' && c<='z') || 
				(c>='A' && c<='Z') || 
				c=='_' || c=='$') {
				i=1;
				buffer[0]=c;
				while(c=oprand[pos++]) {
					if((c>='a' && c<='z') ||
					   (c>='A' && c<='Z') ||
					   (c>='0' && c<='9') ||
					   (c=='_') || (c=='.')) buffer[i++]=c;
					else { pos--; break; }
					}
				buffer[i++] = '\0';
#ifdef MC68000
				if(buffer[2] == '.' &&
					( buffer[3] == 'w' || buffer[3] == 'l')
				    && buffer[4] == '\0') {
					buffer[2] = '\0';
					p = lookup(buffer,DEF);
					if(p!= (struct symbol *)NULL
						|| (p->flag&N_TYPE)==REG) {
						stkval[sp] = 0377&p->value;
						stksym[sp] = p;
						unlex((buffer[3]=='w')?SIZEW:
							SIZEL);
						return(NUMBER);
						}
					else buffer[2] = '.';
					}
#endif
				p = lookup(buffer,DEF);
				if(p==(struct symbol *)NULL)  error('U');
				else if((p->flag&N_TYPE)==REG) {
					stkval[sp] = 0377&p->value;
					stksym[sp] = p;
					return(NUMBER);
					}
				else {
					stkval[sp] = (p->flag==(N_UNDF|N_EXT))?
						0L: p->value;
					stksym[sp] = p;
					return(NUMBER); 
					}
			}
		}
	}
}
