/***************************************************
 *                                                 *
 *    Macro Assembler			           *
 *                                                 *
 *    Written by Richard Cornwell                  *
 *               3/20/86                           *
 *                                                 *
 ***************************************************/

#include "macro.h"

#define REGFIELD(x)	((x>>8)&0377)

machine(ptr)	struct opcodes *ptr; 
{
	register int i, sz, flag;
	unsigned int base, mode;
	struct ex right;

	base = ptr->base;
	pos = 0;
	sz = 1;
	if(labfld) enter(labfld,location,section);
	right.mode = 0;
	i = ptr->type;
	if(i&RIGHT) {
		if(address(&right,0) != 0) error('X');
		}
	switch(i&0x7f) {
	case TBRL:
		sz = 2;
	case TBRS:
		valid(right.mode,VEXT);
		right.val =  right.val-(location+((base&0xff00)?4:2));
		if((right.sym->flag&N_TYPE) != section && pass == 2) error('R');
		if(sz == 1) {	/* quick case */
			i = right.val&(~0x7f);
			if(pass == 2) 
				if(!(i!=0 || i!=(~0x7f))) error('B');
			right.val &= 0377;
			right.mode = MDIR;
			}
		right.sym = P_ABS;
		break;
	case TBYT:
		valid(right.mode,VIMD);
		break;
	case TLEA:	
		valid(right.mode,VINX);
		break;
	case TMEM:	
		valid(right.mode,VEXT|VINX);
		base |= (right.mode&RMODE)>>4;
		break;
	case TOPR:	
		valid(right.mode,VOPR);
		base |= (right.mode&RMODE)>>4;
		break;
	case TSTA:
		valid(right.mode,VDIR|VEXT|VINX);
		base |= (right.mode&RMODE)>>4;
		break;
	case TREG:
		if(expr(&right) != 2) error(',');
		if((right.sym->flag&N_TYPE) != REG) error('A');
		sz = (right.sym->value>>4)&0xf0;
		if((i = expr(&right)) != 0 && i != 1) error('X');
		if((right.sym->flag&N_TYPE) != REG) error('A');
		sz |= (right.sym->value>>8)&0x0f;
		if((sz&0x88) != 0 || (sz&0x88) != 0x88) error('R');
		right.mode = MDIR;
		right.val = sz;
		right.sym = P_ABS;
		sz = 1;
		break;
	case TSIX:
		valid(right.mode,VOPR);
		base |= (right.mode&RMODE)>>4;
		sz = 2;
		break;
	case TSTK:
		sz = 0;
		do {
			if((i = expr(&right)) == -1) break;
			if((right.sym->flag&N_TYPE) != REG) error('A');
			sz |= right.sym->value&0xff;
		} while(i == 2);
		right.mode = MDIR;
		right.val = sz;
		right.sym = P_ABS;
		sz = 1;
		break;
	case TZER:	
		right.mode = MZER;
		break;
	}
	if(base&0xff00) genword((base>>8)&0xff,P_ABS,1);
	genword(base&0xff,P_ABS,1);
	genea(&right,sz);
	printit();
}


/* Eval an addressing mode. */

int address(p,ind)
register struct ex *p;
int ind;
{ register int x, y, z;

	sp = 0;
	oldptr = -1;
	p->val = 0;
	p->sym = P_ABS;
	x = lex();
	switch(x) {
	case RBRACE:
		if(ind) error('[');
		if((x = address(p,1)) != 2) error(']');
		switch(p->mode&RMODE) {
		case MIMD:
		case MDIR:
			error('I');
			break;
		case MEXT:
			p->mode = 0x9f|MINX;
			break;
		case MINX:
			if((p->mode&0x80)==0) {
				p->val = p->mode&0x1f;
				if(p->val&0x10) p->val |= 0xffe0;
				p->mode = MINX|0x98|(p->mode&0x60);
				break;
				}
			if((p->mode&0xf) == 0 || (p->mode&0xf) == 2) error('I');
			else    p->mode |= 0x10;
			break;
			}
		return(0);
	case NUM:
		x = orop();
		p->val = stkval[0];
		p->sym = stksym[0];
		p->mode = MIMD;
		break;
	case GT:
		x = orop();
		p->val = stkval[0];
		p->sym = stksym[0];
		p->mode = MDIR;
		break;
	case COMMA:
		x = lex();
		y = 0x84;
		if(x == MINUS) {
			y = 0x82;
			if(( x=lex()) == MINUS) {y = 0x83; x = lex(); }
			}
		if(x != NUMBER && (stksym[sp]->flag&N_TYPE) != REG) error('A');
		z = index(((stksym[sp]->value)>>8)&0xf);
		x = lex();
		if(x == PLUS) {
			if(y != 0x84) error('A');
			y = 0x80;
			if(( x =lex()) == PLUS) {y = 0x81; x = lex(); }
			}
		p->mode = MINX|z|y;
		break;
	case NUMBER:
		if((stksym[sp]->flag&N_TYPE) == REG) {
			y = ((stksym[sp]->value)>>8)&0xf;
			if( lex() != COMMA) error('A');
			x = lex();
			if((stksym[sp]->flag&N_TYPE) != REG) error('A');
			z = index(((stksym[sp]->value)>>8)&0xf);
			switch(y) {
				case REGA:	y = 0x86;	break;
				case REGB:	y = 0x85;	break;
				case REGD:	y = 0x8b;	break;
				default:	error('A');
				}
			p->mode = MINX|z|y;
			x = lex();
			break;
		}
		if(stksym[sp] == P_ABS &&
		   stkval[sp] <= 16  && stkval[sp] >= -16) {
			y = stkval[sp];
			if( lex() != COMMA) {
				p->val=stkval[sp];
				p->sym=stksym[sp];
				p->mode = MEXT;
				break;
				}
			x = lex();
			if((stksym[sp]->flag&N_TYPE) != REG) error('A');
			z = index(((stksym[sp]->value)>>8)&0xf);
			x = lex();
			p->val = stkval[sp];
			p->sym = stksym[sp];
			p->mode = MINX|z|(y&0x1f);
			}
		/* fall thru */
	default:
	l:	unlex(x);
		x = orop();
		switch(x) {
		case EOL:
		case -1:
			p->val = stkval[0];
			p->sym = stksym[0];
			p->mode = MEXT;
			break;
		case COMMA:
			x = lex();
			if(x != NUMBER && (stksym[sp]->flag&N_TYPE) != REG)
				error('A');
			z = ((stksym[sp]->value)>>8)&0xf;
			if(z == REGP)	z = 0x8d;
			else 		z = 0x89|index(z);
			x = lex();
			sp--;
			p->val = stkval[sp];
			p->sym = stksym[sp];
			p->mode = MINX|z;
			break;
		default: error('*');
		}
	}
	switch(x) {
		case -1: return(0);
		case EOL: return(0);
		case LBRACE: return(2);
		default: return(-1);
		}
	}

int
index(x)	int x;
{
	switch(x) {
	case REGX:	return(0x00);
	case REGY:	return(0x20);
	case REGU:	return(0x40);
	case REGS:	return(0x60);
	}
	error('A');
}

swap(a,b)
struct ex *a, *b;
{
	register int i;
	register struct symbol *p;
	
	i=a->val;
	a->val = b->val;
	b->val = i;
	p=a->sym;
	a->sym = b->sym;
	b->sym = p;
	i=a->mode;
	a->mode = b->mode;
	b->mode = i;
	}

int valid(addr,mode) unsigned addr, mode;
{
	switch(addr&RMODE) {
		case MZER:	if(mode&VZER) return; else break;
		case MEXT:	if(mode&VEXT) return; else break;
		case MIMD:	if(mode&VIMD) return; else break;
		case MDIR:	if(mode&VDIR) return; else break;
		case MINX:	if(mode&VINX) return; else break;
		}
	error('A');
}

int genea(p,sz) struct ex *p; unsigned sz;
{
	switch(p->mode&RMODE) {
	case MZER:
		return;	/* nothing to do */
	case MEXT:
		sz = 2;
	case MIMD:
		genword(p->val,p->sym,sz);
		return;
	case MDIR:
		genword(p->val,P_ABS,1);
		return;
	case MINX:
		genword(p->mode&0xff, P_ABS, 1);
		if((p->mode&0x80) == 0) return;
		switch(p->mode&0xf) {
		case 0:  case 1:  case 2:  case 3:
		case 4:  case 5:  case 6:  case 11:
			return;
		case 7:  case 10: case 14:
			error('P');
			return;
		case 8:  case 12:
			genword(p->val,P_ABS);
			return;
		case 9:   case 13: case 15:
			genword(p->val,p->sym,2);
			return;
		}
	}
}

