
/***************************************************
 *                                                 *
 *    Macro Assembler			           *
 *                                                 *
 *    Copyright 1989    Richard P. Cornwell        *
 *    Developmental Code not for redistubution     *
 *                                                 *
 *    Written by Richard Cornwell                  *
 *               3/20/86                           *
 *                                                 *
 ***************************************************/

#include "macro.h"

_PROTOTYPE( int address,(struct ex *p));
_PROTOTYPE( int swap,	(struct ex *a, struct ex *b));
_PROTOTYPE( int valid,	(unsigned addr, unsigned mode));
_PROTOTYPE( int genea,	(struct ex *p, unsigned sz));

#define REGFIELD(x)	((x>>8)&0377)

machine(ptr)	struct opcodes *ptr; 
{
	register int i, sz, flag;
	unsigned int base, mode;
	struct ex right, left;

	base = ptr->base;
	pos = 0;
	sz = size;
	if(labfld) enter(labfld,location,section);
	i = ptr->type;
	left.mode = 0;
	right.mode = 0;
	if(i&TLEFT)		flag = address(&left);
	if(i&TRIGHT) {
		if(flag!=2)	error('T');
		else		flag = address(&right);
		}
	if(i&TVAR) {
		if(flag!=2)	flag = 3;
		else		flag = address(&right);
		}
	switch(i) {

	case	TADD:
		/* add, sub */
		if(sz == 0) sz=2;  /* defualt to word */
		mode = (sz-1)<<6;
		if((right.mode&RMODE) == REGA) {
			/* make it into a adda/suba */
			if(sz==1) sz=2; /* force byte to word on reg's */
			mode = (sz == 3)?0700: 0300;
			}
		else if((right.mode&RMODE) != REGD &&
			(left.mode&RMODE) == REGD) {
			/* flip right and left if left is a data reg. */
			swap(&right,&left);
			mode |= 0400;	/* set reverse flag */
			}
		else if(right.mode == MIMD) error('A');
		if(left.mode == MIMD) {
			if((left.sym->flag&N_TYPE) == N_ABS 
				&& valid(right.mode,VALA)
				&& left.val <= 8 && left.val >= 1) {
			/* make it quick mode */	/* sub? */
				mode = (sz-1)<<6;
				base = 050000 | mode | ((base&040000)?0: 0400); 
				base |= (right.mode&077);
				if(left.val!=8) base |= (left.val<<9);
				left.mode = 0;
				}
			else {
			/* make it immedate */
				if((right.mode&RMODE)==REGA) {
					base |= (sz==3)? 0774 : 0374;
					base |= (right.mode&07)<<9;
				}
				else {	/* sub? */
					mode |= ((base&040000)?01000: 0);
					base = 002000| mode | (right.mode&077);
					}
				}
			break;
			}
		else if(!valid(right.mode,VDRG|VARG)) error('A');
		/* finaly build to instruction */
		base |= mode | (left.mode&077) | ((right.mode&07)<<9);
		break;

	case	TBIT:
		/* bchg, bclr, bset, btst */
		if(left.mode == MIMD) base ^= 004400;
		else if(!valid(left.mode,VDRG)) error('A');
		else base |= ((left.mode&07)<<9);
		base |= right.mode&077;
		if(left.mode != MIMD) left.mode = 0;
		if(!valid(right.mode,VALT)) error('A');
		sz = 2;
		break;

	case	TBRA:
		/* bcc, bra, bsr */
		if(!valid(left.mode,VDIR)) error('R');
		left.mode = MDIR;
		left.val =  left.val-(location+2);
		if((left.sym->flag&N_TYPE) != section && pass == 2) error('R');
		if(sz == 4 || (jflag && (left.val&(~0377)) == (~0377))) {
			/* quick case */
			base |= left.val&0377;
			left.mode = 0;
			}
		else { /* long case */
			if(left.val < -32768 && left.val > 32768) error('B');
			left.sym = P_ABS;
			}
		break;

	case	TCMP:
		/* cmp */
		if(sz == 0) sz = 2;
		if(valid(right.mode,VARG)) mode = (sz==3)?0700:0300;
		else if(valid(left.mode,VPOS) && valid(right.mode,VPOS)) {
			left.mode = (left.mode&07)|REGA;
			mode = ((sz-1)<<6) | 0400;
			}
		else if(left.mode == MIMD) {
			base = 0006000 | ((sz-1)<<6)  |  (right.mode&077);
			break;
			}
		else if(valid(right.mode,VDRG)) mode = (sz-1)<<6;
		else error('A');
		base |= mode | ((right.mode&07)<<9) | (left.mode&077);
		break;

	case	TDBR:
		/* dbcc */
		if(!valid(left.mode,VDRG)) error('A');
		base |= left.mode&07;
		if(!valid(right.mode,VDIR)) error('A');
		right.mode = MDIR;
		right.val = right.val-(location+2);
		if((right.sym->flag&N_TYPE) != section && pass == 2)
			error('R');
	/*	mode = right.val & (~32768);
		if((mode != 0 && mode != (~32768)) && pass == 2)
			error('B'); */
		right.sym = P_PCR;
		break;

	case	TLNK:
		/* link */
		if(!valid(left.mode,VARG)) error('A');
		base |= left.mode&07;
		if(right.mode != MIMD) error('A');
		break;

	case	TLOG:
		/* and, eor, or */
		if(sz == 0) sz=2;  /* defualt to word */
		mode = (sz-1)<<6;
		if(!valid(right.mode,VDRG)) {
			/* See if it is valid */
			if(!valid(left.mode,VDRG)) {
			    if(left.mode!=MIMD) error('A');
			    else if((right.mode==REGC) || (right.mode==REGS)) {
				base =   (base==0140000) ? 01074:
					((base==0130000) ? 05074: 00074);
				if(right.mode==REGS) base |= 0100;
				sz = 2;
				break;
				}
			}
			else {
				mode |= 0400;		/* set the mode bit */
				swap(&right,&left);
				}
			}
		if(right.mode==MIMD)	error('A');
		else if(left.mode==MIMD) {
			/* make it immedate */
			if(base == 0130000) base = 005000;
			if(base == 0140000) base = 001000;
			if(base == 0100000) base = 000000;	
			base |= mode | (right.mode&077);
			break;
			}
		else if(!valid(right.mode,VDRG)) error('A');
		/* finaly build to instruction */
		base |= mode | (left.mode&077) | ((right.mode&07)<<9);
		break;

	case	TMVQ:
		/* moveq */
		sz = 3;
	case	TMOV:
		/* move */
		if(sz == 0) sz=2;  /* defualt to word */
		if(right.mode == REGU || right.mode == REGC
				 || right.mode == REGS) {
			if(right.mode == REGU) {
				if(!valid(left.mode,VARG)) error('A');
				else base = 047140;
				}
			else {
				if(!valid(left.mode,VLOG|VIMD)) error('A');
				else base = (right.mode==REGS)?043300: 042300;
				}
			base |= left.mode&077;
			sz = 2;
			}
		else if(left.mode == REGU || left.mode == REGC 
				|| left.mode == REGS) {
			if(left.mode == REGU) {
				if(!valid(right.mode,VARG)) error('A');
				else base = 047150;
				}
			else {
				if(!valid(right.mode,VALT)) error('A');
				else base = (left.mode==REGS)?040300: 041300;
				}
			base |= right.mode&077;
			sz = 2;
			}
		else if(!valid(right.mode,VALA)) error('A');
		else if(sz == 3 && left.mode == MIMD &&
			  valid(right.mode,VDRG) && (left.sym->flag&07) == N_ABS
			   && abs(left.val) <128) {
			/* make it a move quick */
			base = 070000 | ((right.mode&07)<<9) | (left.val&0377);
			left.mode = 0;
			}
		else  {
			switch(sz) {
				case 1:  base = 010000; break;
				case 2:  base = 030000; break;
				case 3:  base = 020000; break;
				}
			base |= ((right.mode&7)<<9) |
				 ((right.mode&070)<<3) | (left.mode&077);
			}
		break;

	case	TMVM:
		/* movem */
		if(sz==3) base |= 0100;
		/* Turn single register into a list */
		if(valid(right.mode,VDRG|VARG)) {
			right.val = 1<<((((right.mode&RMODE)==REGA)? 8:0)
				+(right.mode&7));
			right.mode = MLST;
		} else if(valid(left.mode,VDRG|VARG)) {
			left.val = 1<<((((left.mode&RMODE)==REGA)? 8:0)
				+(left.mode&7));
			left.mode = MLST;
		}
		if(right.mode==MLST || right.mode == MIMD) {
			/* Reverse everything */
			swap(&left,&right);
			base |= 02000;
		} else if(valid(right.mode,VPRE) && left.mode==MLST) {
			/* reverse the list too */
			register int j;

			for(j=i=0; i<16; i++) {
				j |= left.val&1;
				left.val >>= 1;
				j <<= 1;
			}
			/* back it up one */
			left.val = j>>1;
		} else if(left.mode==MLST || left.mode==MIMD) base |= 0;
		else error('A');
		if(!valid(right.mode,VIND|VPOS|VPRE|VINX|VTWO|VDIR|VIPC|VTPC)) 
						error('A');
		if(right.mode==MLST || right.mode==MIMD) swap(&left,&right);
		/* finaly build to instruction */
		base |= (right.mode&077);
		sz = 2;
		break;

	case	TMVP:
		/* movep */
		if(sz == 0) sz=2;  /* defualt to word */
		if(sz==3) base |= 0100;
		if(valid(left.mode,VDRG) && valid(right.mode,VINX)) {
			/* Reverse everything */
			swap(&right,&left);
			base |= 0200;
			}
		else if(valid(left.mode,VINX) && valid(right.mode,VDRG)) {
			/* nothing to do */}
		else error('A');
		/* finaly build instruction */
		base |= (left.mode&07) | ((right.mode&07)<<9);
		break;

	case	TONE:
		/* clr, jmp, jsr, nbcd, neg, negx, not, pea, scc, tas, tst */
		if((base&0174777) == 040000 || base == 045000 ) {
			if(!valid(left.mode,VALT)) error('A');
			if(sz == 0) sz = 2;
			base |= (sz-1)<<6;
			}
		else if((base&0177600)==047200 || base==044100) {
			if(!valid(left.mode,VIND|VINX|VTWO|VDIR|VIPC|VTPC))
				error('A');
			}
		else if(!valid(left.mode,VALT)) error('A');
		right.mode = 0;
		base |= (left.mode&077);
		break;

	case	TREG:
		/* abcd, addx, sbcd, subx */
		if((right.mode&RMODE) != (left.mode&RMODE)) error('A');
		if(!valid(right.mode,VDRG|VPRE)) error('A');
		if(base == 0150400 || base == 0110400) {
			if(sz == 0) sz = 2;
			base |= ((sz-1)<<6);
			}
		if(valid(right.mode,VPRE)) base |= 010;
		base |= (left.mode&07) | ((right.mode&07)<<9);
		break;

	case	TRG1:
		/* chk, divs, divu, lea, muls, mulu */
		if(base == 040700) {
			if(!valid(right.mode,VARG)) error('A');
			if(!valid(left.mode,VIND|VINX|VTWO|VDIR|VIPC|VTPC))
					error('A');
			sz = 3;
			}
		else {
			if(!valid(right.mode,VDRG)) error('A');
			if(!valid(left.mode,VALT|VIMD)) error('A');
			sz = 2;
			}
		base |= (left.mode&077) | ((right.mode&07)<<9);
		break;

	case	TRG3:
		/* exg */
		if(!valid(left.mode,VARG|VDRG)) error('A');
		if(!valid(right.mode,VARG|VDRG)) error('A');
		if((right.mode&RMODE)==(left.mode&RMODE)) 
			mode = 0100 | (valid(left.mode,VARG)?010:0);
		else {
			mode = 0110;
			if(valid(right.mode,VDRG)) swap(&left,&right);
			}
		base |= mode|((left.mode&07)<<9)|(right.mode&07);
		break;
			
	case	TRG4:
		/* ext, swap, unlk */
		if(base == 044000) {				/* ext */
			if(!valid(left.mode,VDRG)) error('A');
			if(sz==0) sz=2;
			if(sz==1) error('U');
			base |= sz<<6;
			}
		else if(base == 044100 && !valid(left.mode,VDRG))
			error('A');				/* swap */
		else if(base == 047130 && !valid(left.mode,VARG))
			error('A');				/* unlk */
		base |= (left.mode&07);
		break;

	case	TRTD:
		/* rtd, stop */
		if(left.mode != MIMD) error('A');
		sz = 2;
		break;

	case	TSHF:
		/* asl, asr, lsl, lsr, rol, ror, roxl, roxr */
		if(sz == 0) sz=2;
		if(flag==3 && valid(left.mode,VDRG)) {
			right.mode = left.mode;
			left.val = 1;	/* fake shift */
			left.sym = P_ABS;
			left.mode = MIMD;
			}	
		else if(flag==3) {
			if(sz != 2) error('U');
			if(!valid(left.mode,VIND|VPRE|VPOS|VINX|VTWO|VDIR))
				error('A');
			base |= 0300 | left.mode&077;
			right.mode = 0;
			break;
			}
		base |= (sz-1)<<6;
		if(!valid(right.mode,VDRG)) error('A');
		if(!valid(left.mode,VDRG|VIMD)) error('A');
		if(valid(left.mode,VDRG)) {
			base |= 040;
			}
		else {
			if(left.sym->flag != N_ABS && pass == 2) error('A');
			if((left.val <0 || left.val >8)&& pass == 2) error('B');
			left.mode = left.val&07;
			}
		base |= (right.mode&07) | ((left.mode&07)<<9);
		left.mode = 0;
		break;

	case	TTRP:
		/* trap */
		if(left.mode != MIMD) error('A');
		if(left.sym->flag != N_ABS && pass==2) error('A');
		left.mode = 0;
		base |= (left.val&017);

	case	TZER:
		/* nop, reset, rte, rtr, rts, trapv */
		break;
	case	DC:
		/* handle dc opcode */
		{	static struct opcodes temp = 
			{ "dc", BYTE, 0 };
			switch(sz) {
			case 1:	
				temp.type = BYTE; break;
			case 0:
			case 2:
				temp.type = WORD; break;
			case 3:
				temp.type = LONG; break;
			}
			psuedo(&temp);		/* go do it */
			return;			/* no code to gen */
		}
	}
	genword(base,P_ABS,2);
	genea(&left,sz);
	genea(&right,sz);
	printit();
}

void opscan(ptr)
char *ptr;
{	char *s = ptr;
	size = 0;
	if(*s == '.')	s++;
	for(; *s; s++) {
	 	if(*s == '.') {
			switch(s[1]) {
			case 'b': size = 1; break;
			case 'w': size = 2; break;
			case 'l': size = 3; break;
			case 's': size = 4; break;
			}
		*s = '\0';
		break;
		}
	}
}

/* Eval an addressing mode. */

int address(p)
register struct ex *p;
{ register int x, y, z;

	sp = 0;
	oldptr = -1;
	p->val = 0;
	p->sym = P_ABS;
	x = lex();
	switch(x) {
	case NUMBER:
		if((stksym[sp]->flag&N_TYPE) != REG) goto l;
		switch(REGFIELD(stksym[sp]->value)) {
		case CCR:
			p->mode = REGC;
			x = lex();
			break;
		case USP:
			p->mode = REGU;
			x = lex();
			break;
		case SR:
			p->mode = REGS;
			x = lex();
			break;
		case DREG:
		case AREG:
			y = REGFIELD(stksym[sp]->value);
			sp++;
			x = lex();
			if(x==MINUS || x==DIVIDE) {
				sp--;
				if(y==AREG) stkval[sp] += 8;
				stkval[sp] |= stkval[sp]<<4;
				while(x==MINUS || x==DIVIDE) {
					y = x;
					sp++;
					x = lex();
					if(x!=NUMBER || 
					  (stksym[sp]->flag&N_TYPE) != REG)
						 error('X');
					x = REGFIELD(stksym[sp]->value);
					if(x==AREG) stkval[sp] += 8;
					if(x!=DREG && x!=AREG)
						error('X');
					stkval[sp] |= stkval[sp]<<4;
					if(y==MINUS) {
						register int a,b;
						a = stkval[sp--]&017;
						b = stkval[sp]&017;
						stkval[sp] = (max(a,b)<<4) |
							min(a,b);
						}
					x = lex();
					}
				for(p->val = 0; sp>= 0; sp--)
					p->val |= (1<<(1+((stkval[sp]>>4)&017)))
						- (1<<(stkval[sp]&017));
				p->mode = MLST;
				}
			else {
				p->mode = ((y == DREG)?REGD: REGA)|stkval[--sp];
				}
			break;
			}
		break;
	case NUM:
		x = orop();
		p->val = stkval[0];
		p->sym = stksym[0];
		p->mode = MIMD;
		break;
	case MINUS:
		x = lex();
		if(x == RPARN) {
			x = lex();
			if(x == NUMBER && (stksym[sp]->flag&N_TYPE) == REG
				&& REGFIELD(stksym[sp]->value) == AREG) {
				p->mode = MPRE | (stkval[0]&07);
				if(lex() != LPARN) error(')');
				x = lex();
				break;
				}
			unlex(x);
			x = RPARN;
			}
		unlex(x);
		x = MINUS;
		goto l;
	case RPARN:
		x = lex();
		if(x == NUMBER && (stksym[sp]->flag&N_TYPE) == REG
				&& REGFIELD(stksym[sp]->value) == AREG) {
			p->mode = stkval[0]&07;
			x = lex();
			if(x == COMMA) {
				sp++;
				z = lex();
				if(z != NUMBER ||
				  (stksym[sp]->flag&N_TYPE) != REG) error('X');
				else {
					z = REGFIELD(stksym[sp]->value);
					if(z != AREG && z != DREG) error('X');
					}
				p->mode = (((z == AREG)? REGA: REGD)
						 | stkval[sp--])<<7;
				p->mode |= (y == PC) ? MTPC :
					(MTWO | stkval[sp]);
				x = lex();
				if(x == SIZEL || x == SIZEW) {
					if(x == SIZEL) p->mode |= 1<<14;
					x = lex();
					}
				p->val = 0;
				p->sym = P_ABS;
				if(x != LPARN) error(')');
				x = lex();
				break;
				}
			if(x != LPARN) error(')');
			x = lex();
			p->mode |= (x == PLUS)? MPOS: MIND;
			if(x == PLUS) x = lex();
			break;
			}
		unlex(x);
		x = RPARN;
	default:
	l:	unlex(x);
		x = orop();
		switch(x) {
		case COMMA:
		case EOL:
		case -1:
			p->val = stkval[0];
			p->sym = stksym[0];
			p->mode = MDIR | 1;
			break;
		case SIZEL:
		case SIZEW:
			p->val = stkval[0];
			p->sym = stksym[0];
			p->mode = MDIR | (x==SIZEL);
			x = lex();
			break;
		case RPARN:
			sp++;
			y = lex();
			if(y != NUMBER || (stksym[sp]->flag&N_TYPE) != REG) {
				error('A');
				break;
				}
			else {
				y = REGFIELD(stksym[sp]->value);
				if (y != AREG && y != PC) {
					error('A');
					break;
					}
				}
			sp++;
			z = lex();
			if(z == LPARN) {
				sp--;
				p->mode = (y == PC)? MIPC: (MINX | stkval[sp]);
				}
			else if(z == COMMA) {
				z = lex();
				if(z != NUMBER ||
				  (stksym[sp]->flag&N_TYPE) != REG) error('X');
				else {
					z = REGFIELD(stksym[sp]->value);
					if(z != AREG && z != DREG) error('X');
					}
				p->mode = (((z == AREG)? REGA: REGD)
						 | stkval[sp--])<<7;
				p->mode |= (y == PC) ? MTPC :
					(MTWO | stkval[sp]);
				z = lex();
				if(z == SIZEL || z == SIZEW) {
					if(z == SIZEL) p->mode |= 1<<14;
					z = lex();
					}
				if(z != LPARN) error(')');
				}
			else error('*');
			p->val = stkval[0];
			p->sym = stksym[0];
			x = lex();
			break;
		default: error('*');
		}
	}
	switch(x) {
		case -1: return(0);
		case EOL: return(1);
		case COMMA: return(2);
		default: return(-1);
		}
	}


swap(a,b)
struct ex *a, *b;
{
	register int i;
	register struct symbol *p;
	
	i=a->val;
	a->val = b->val;
	b->val = i;
	p=a->sym;
	a->sym = b->sym;
	b->sym = p;
	i=a->mode;
	a->mode = b->mode;
	b->mode = i;
	}

int valid(addr,mode) unsigned addr, mode;
{
	switch(addr&RMODE) {
		case REGD:	return(0!=(mode&VDRG));
		case REGA:	return(0!=(mode&VARG));
		case MIND:	return(0!=(mode&VIND));
		case MPOS:	return(0!=(mode&VPOS));
		case MPRE:	return(0!=(mode&VPRE));
		case MINX:	return(0!=(mode&VINX));
		case MTWO:	return(0!=(mode&VTWO));
		}
	switch(addr&(RMODE|7)) {
		case MIMD:	return(0!=(mode&VIMD));
		case MDIR|1:
		case MDIR:	return(0!=(mode&VDIR));
		case MTPC:	return(0!=(mode&VTPC));
		case MIPC:	return(0!=(mode&VIPC));
		case REGC:
		case REGU:
		case REGS:
		case MLST:	return(0);
		}
}

int genea(p,sz) struct ex *p; unsigned sz;
{
	switch(p->mode&RMODE) {
		case REGD:
		case REGA:
		case MIND:
		case MPOS:
		case MPRE:
			return;	/* nothing to do */
		case MINX:
			genword(p->val,p->sym,2);
			return;
		case MTWO:
			if((p->sym->flag&N_TYPE) != N_ABS &&
			   0 != (p->val&(~0377)) &&
			   (~0377) != (p->val&(~0377))) error('B');
			p->val &= 0377;
			p->val |= ((p->mode>>7)&07)<<12;
			if(REGA == (RMODE&(p->mode>>7))) p->val |= 0100000;
			if((1<<14)&p->mode) p->val |= 04000;
			genword(p->val,P_ABS,2);
			return;
		}
	switch(p->mode&(RMODE|7)) {
		case MIPC:
			if((((p->sym->flag&N_TYPE) != section) &&
			   ((p->sym->flag&N_TYPE) != N_ABS)) && pass != 1) 
				error('R');
			if((p->sym->flag&N_TYPE) != N_ABS)
				p->val -= location;
			p->sym = P_PCR;
			genword(p->val,p->sym,2);
			return;
		case MTPC:
			if((((p->sym->flag&N_TYPE) != section) &&
			   ((p->sym->flag&N_TYPE) != N_ABS)) && pass != 1) 
				error('R');
			if((p->sym->flag&N_TYPE) != N_ABS)
				p->val -= location;
			p->sym = P_ABS;
			if(0 != (p->val&(~0377)) &&
			  (~0377) != (p->val&(~0377)) && pass != 1) error('B');
			p->val &= 0377;
			p->val |= ((p->mode>>7)&07)<<12;
			if(REGA == (RMODE&(p->mode>>7))) p->val |= 0100000;
			if((1<<14)&p->mode) p->val |= 04000;
			genword(p->val,P_ABS,2);
			return;
		case MLST:
		case MIMD:
			if(sz==3)	genword(p->val,p->sym,4);
			else		genword(p->val,p->sym,2);
			return;
		case MDIR:
		case MDIR|1:
			if(p->mode&1)	genword(p->val,p->sym,4);
			else		genword(p->val,p->sym,2);
			return;
	}
}

