
/***************************************************
 *                                                 *
 *    Macro Assembler				   *
 *                                                 *
 *    Copyright 1989    Richard P. Cornwell        *
 *    Developmental Code not for redistubution     *
 *                                                 *
 *    Written by Richard Cornwell                  *
 *               3/20/86                           *
 *                                                 *
 ***************************************************/

#define DTITLE "68000 Macro V2.0"

/* MC68000 needs to run opscan */
#define SCANOPC
/* MC68000 supports flexable names */
#define FLEXNAMES
/* MC68000 is a word aligned machine */
#define ALIGN 1
/* MC68000 is a 32 bit address machine */
#define ADDRSZ 8
#define MC68000
#define CPU_TYPE	01

/* Addressing modes */
#define  REGD	000			/* reg<0:3> */
#define  REGA	010			/* reg<0:3> */
#define  REGC 	0170
#define  REGU 	0171
#define  REGS 	0172
#define  MIND	020			/* reg<0:3> */
#define  MPOS	030			/* reg<0:3> */
#define  MPRE	040			/* reg<0:3> */
#define  MINX	050			/* reg<0:3> */
#define  MTWO 	060			/* reg<0:3> , second <7:10> size<14>*/
#define  MIMD	074
#define  MTPC 	073			/* reg<0:3> , second <7:10> size<14>*/
#define  MIPC	072
#define  MDIR	070			/* size in <0> */
#define  MLST	0177
#define  RMODE	0170

/* Address mode masks */
#define  VDRG	0000001
#define  VARG	0000002
#define  VIND	0000004
#define  VPOS	0000010
#define  VPRE	0000020
#define  VINX	0000040
#define  VTWO 	0000100
#define  VDIR	0001400
#define  VIPC	0002000
#define  VTPC 	0004000
#define  VIMD	0010000

#define  VALT	VDRG|VIND|VPOS|VPRE|VINX|VTWO|VDIR
#define  VALA	VALT|VARG
#define  VLOG	VALT|VIPC|VTPC

/* Opcode types */
#define TRIGHT	02000
#define TLEFT	01000
#define TBOTH	03000
#define TVAR	05000
#define	TADD	(60|TBOTH)
#define	TBIT	(61|TBOTH)
#define	TBRA	(62|TLEFT)
#define	TCMP	(63|TBOTH)
#define	TDBR	(64|TBOTH)
#define	TLNK	(65|TBOTH)
#define	TLOG	(66|TBOTH)
#define	TMOV	(67|TBOTH)
#define	TMVM	(68|TBOTH)
#define	TMVP	(69|TBOTH)
#define	TONE	(70|TLEFT)
#define	TREG	(71|TBOTH)
#define	TRG1	(72|TBOTH)
#define	TRG2	(73|TBOTH)
#define	TRG3	(74|TBOTH)
#define	TRG4	(75|TLEFT)
#define	TRTD	(76|TLEFT)
#define	TSHF	(77|TVAR)
#define	TTRP	(78|TLEFT)
#define	TZER	(79)
#define TMVQ	(80|TBOTH)
#define DC	(81)

/* User defined tokens */
#define CCR	30
#define SR	31
#define USP	32
#define PC	33
#define DREG 	34
#define AREG	35
#define SIZEL	36
#define SIZEW	37

