/***************************************************
 *                                                 *
 *    Macro Assembler			           *
 *                                                 *
 *    Copyright 1989    Richard P. Cornwell        *
 *    Developmental Code not for redistubution     *
 *                                                 *
 *    Written by Richard Cornwell                  *
 *               3/20/86                           *
 *                                                 *
 ***************************************************/

#include "macro.h"

struct opcodes optab[] = {
	".ascii",	ASCII,	0,
	".asciz",	ASCIZ,	0,
	".bss",		BSS,	0,
	".comm",	COMM,	0,
	".data",	DSECT,	0,
	".dc",		DC,	0,
	".ds",		BLOCK,	0,
	".end",		END,	0,
#ifdef MAXCOND
	".endc",	ENDC,	0,
#endif
	".entry",	ENTRY,	0,
	".equ",		EQU,	0,
	".even",	EVEN,	0,
	".extern",	EXTERN,	0,
	".globl",	GLOBAL,	0,
#ifdef MAXCOND
	".if",		IF,	0,
	".ifd",		IFD,	0,
	".ife",		IFE,	0,
	".iff",		IFF,	0,
	".ifn",		IFN,	0,
	".ift",		IFT,	0,
	".iftf",	IFTF,	0,
	".ifu",		IFU,	0,
#endif
	".lcomm",	LCOMM,	0,
#ifdef MACASM
	".macro",	MACRO,	0,
	".mend",	MEND,	0,
	".mglb",	MGLB,	0,
	".mgo",		MGO,	0,
	".mlcl",	MLCL,	0,
	".mset",	MSET,	0,
	".msetl",	MSETL,	0,
#endif 
	".page",	PAGE,	0,
	".print",	PRINT,	0,
	".set",		SET,	0,
	".space",	SPACE,	0,
	".stabd",	STABD,	0,
	".stabn",	STABN,	0,
	".stabs",	STABS,	0,
	".stitle",	STITLE,	0,
	".text",	CSECT,	0,
	".title",	TITLE,	0,
	"abcd",		TREG,	0140400,
	"add",		TADD,	0150000,
	"addq",		TADD,	0150000,
	"addx",		TREG,	0150400,
	"and",		TLOG,	0140000,
	"ascii",	ASCII,	0,
	"asciz",	ASCIZ,	0,
	"asl",		TSHF,	0160400,
	"asr",		TSHF,	0160000,
	"bcc",		TBRA,	0062000,
	"bchg",		TBIT,	0000500,
	"bclr",		TBIT,	0000600,
	"bcs",		TBRA,	0062400,
	"beq",		TBRA,	0063400,
	"bge",		TBRA,	0066000,
	"bgt",		TBRA,	0067000,
	"bhi",		TBRA,	0061000,
	"ble",		TBRA,	0067400,
	"bls",		TBRA,	0061400,
	"blt",		TBRA,	0066400,
	"bmi",		TBRA,	0065400,
	"bne",		TBRA,	0063000,
	"bpl",		TBRA,	0065000,
	"bra",		TBRA,	0060000,
	"bset",		TBIT,	0000700,
	"bsr",		TBRA,	0060400,
	"bss",		BSS,	0,
	"btst",		TBIT,	0000400,
	"bvc",		TBRA,	0064000,
	"bvs",		TBRA,	0064400,
	"chk",		TRG1,	0040600,
	"clr",		TONE,	0041000,
	"cmp",		TCMP,	0130000,
	"cmpm",		TCMP,	0130410,
	"comm",		COMM,	0,
	"data",		DSECT,	0,
	"dbcc",		TDBR,	0052310,
	"dbcs",		TDBR,	0052710,
	"dbeq",		TDBR,	0053710,
	"dbf",		TDBR,	0050710,
	"dbge",		TDBR,	0056310,
	"dbgt",		TDBR,	0057310,
	"dbhi",		TDBR,	0051310,
	"dble",		TDBR,	0057710,
	"dbls",		TDBR,	0051710,
	"dblt",		TDBR,	0056710,
	"dbmi",		TDBR,	0055710,
	"dbne",		TDBR,	0053310,
	"dbpl",		TDBR,	0055310,
	"dbra",		TDBR,	0050710,
	"dbt",		TDBR,	0050310,
	"dbvc",		TDBR,	0054310,
	"dbvs",		TDBR,	0054710,
	"dc",		DC,	0,
	"divs",		TRG1,	0100700,
	"divu",		TRG1,	0100300,
	"ds",		BLOCK,	0,
	"end",		END,	0,
#ifdef MAXCOND
	"endc",		ENDC,	0,
#endif
	"entry",	ENTRY,	0,
	"eor",		TLOG,	0130000,
	"equ",		EQU,	0,
	"even",		EVEN,	0,
	"exg",		TRG3,	0140400,
	"ext",		TRG4,	0044000,
	"extern",	EXTERN,	0,
	"globl",	GLOBAL,	0,
#ifdef MAXCOND
	"if",		IF,	0,
	"ifd",		IFD,	0,
	"ife",		IFE,	0,
	"iff",		IFF,	0,
	"ifn",		IFN,	0,
	"ift",		IFT,	0,
	"iftf",		IFTF,	0,
	"ifu",		IFU,	0,
#endif
	"jmp",		TONE,	0047300,
	"jsr",		TONE,	0047200,
	"lcomm",	LCOMM,	0,
	"lea",		TRG1,	0040700,
	"link",		TLNK,	0047120,
	"lsl",		TSHF,	0160410,
	"lsr",		TSHF,	0160010,
#ifdef MACASM
	"macro",	MACRO,	0,
	"mend",		MEND,	0,
	"mglb",		MGLB,	0,
	"mgo",		MGO,	0,
	"mlcl",		MLCL,	0,
#endif
	"move",		TMOV,	0000000,
	"movem",	TMVM,	0044200,
	"movep",	TMVP,	0000410,
	"moveq",	TMVQ,	0000000,
#ifdef MACASM
	"mset",		MSET,	0,
	"msetl",	MSETL,	0,
#endif 
	"muls",		TRG1,	0140700,
	"mulu",		TRG1,	0140300,
	"nbcd",		TONE,	0044000,
	"neg",		TONE,	0042000,
	"negx",		TONE,	0040000,
	"nop",		TZER,	0047161,
	"not",		TONE,	0043000,
	"or",		TLOG,	0100000,
	"page",		PAGE,	0,
	"pea",		TONE,	0044100,
	"print",	PRINT,	0,
	"reset",	TZER,	0047160,
	"rol",		TSHF,	0160430,
	"ror",		TSHF,	0160030,
	"roxl",		TSHF,	0160420,
	"roxr",		TSHF,	0160020,
	"rtd",		TRTD,	0047164,
	"rte",		TZER,	0047163,
	"rtr",		TZER,	0047167,
	"rts",		TZER,	0047165,
	"sbcd",		TREG,	0100400,
	"scc",		TONE,	0052300,
	"scs",		TONE,	0052700,
	"seq",		TONE,	0053700,
	"set",		SET,	0,
	"sf",		TONE,	0050700,
	"sge",		TONE,	0056300,
	"sgt",		TONE,	0057300,
	"shi",		TONE,	0051300,
	"sle",		TONE,	0057700,
	"sls",		TONE,	0051700,
	"slt",		TONE,	0056700,
	"smi",		TONE,	0055700,
	"sne",		TONE,	0053300,
	"space",	SPACE,	0,
	"spl",		TONE,	0055300,
	"st",		TONE,	0050300,
	"stabd",	STABD,	0,
	"stabn",	STABN,	0,
	"stabs",	STABS,	0,
	"stitle",	STITLE,	0,
	"stop",		TRTD,	0047162,
	"sub",		TADD,	0110000,
	"subq",		TADD,	0110000,
	"subx",		TREG,	0110400,
	"svc",		TONE,	0054300,
	"svs",		TONE,	0054700,
	"swap",		TRG4,	0044100,
	"tas",		TONE,	0045300,
	"text",		CSECT,	0,
	"title",	TITLE,	0,
	"trap",		TTRP,	0047100,
	"trapv",	TZER,	0047166,
	"tst",		TONE,	0045000,
	"unlk",		TRG4,	0047130,
	};

int opsize = sizeof(optab)/sizeof(struct opcodes);

#define DR	(DREG<<8)
#define AR	(AREG<<8)

struct opcodes reglist[] = {
	"a0",		AR|0,		REG,
	"a1",		AR|1,		REG,
	"a2",		AR|2,		REG,
	"a3",		AR|3,		REG,
	"a4",		AR|4,		REG,
	"a5",		AR|5,		REG,
	"a6",		AR|6,		REG,
	"a7",		AR|7,		REG,
	"d0",		DR|0,		REG,
	"d1",		DR|1,		REG,
	"d2",		DR|2,		REG,
	"d3",		DR|3,		REG,
	"d4",		DR|4,		REG,
	"d5",		DR|5,		REG,
	"d6",		DR|6,		REG,
	"d7",		DR|7,		REG,
	"ccr",		(CCR<<8)|16,	REG,
	"usp",		(USP<<8)|17,	REG,
	"sr",		(SR<<8)|18,	REG,
	"sp",		AR|7,		REG,
	"pc",		(PC<<8)|19,	REG,
	NULL,		0,		0 };

