/***************************************************
 *                                                 *
 *    Macro Assembler			           *
 *                                                 *
 *    Copyright 1989    Richard P. Cornwell        *
 *    Developmental Code not for redistubution     *
 *                                                 *
 *    Written by Richard Cornwell                  *
 *               3/20/86                           *
 *                                                 *
 ***************************************************/

#include "macro.h"
struct symbol *symtab = NULL;
struct symbol *globall, *globaln;
int csindex;
int depth;
long int symsize;
struct shortop *opchain = NULL, *nxtop;

struct symbol sects[X_TYPE] = {
	{NULL, 0, 0, 0, N_UNDF, 0, NULL, NULL, NULL, 0},
	{NULL, 0, 0, 0, N_ABS,  0, NULL, NULL, NULL, 0},
	{NULL, 0, 0, 0, N_TEXT, 0, NULL, NULL, NULL, 0},
	{NULL, 0, 0, 0, N_DATA, 0, NULL, NULL, NULL, 0},
	{NULL, 0, 0, 0, N_BSS,  0, NULL, NULL, NULL, 0},
	{NULL, 0, 0, 0, N_UNDF,  0, NULL, NULL, NULL, 0},
	{NULL, 0, 0, 0, N_UNDF, 0, NULL, NULL, NULL, 0}
	};

/* Enter a symbol into the symbol table with type f and value l */
void
enter(p,l,f) char *p; unsigned long l; unsigned int f;
{ register struct symbol *ptr;

	if(p[0] == '\0') return;
	ptr = lookup(p,DEF);
	if(pass == 1) {
		if((ptr->flag&N_TYPE) != N_UNDF) error('M');
		ptr->flag |= f;
		ptr->value = l;
		}
	else {
		if(((ptr->value) != l) || ((ptr->flag&N_TYPE) != (f&N_TYPE))) {
			 error('M');
		}
		if((f&N_TYPE) == N_UNDF)
			error('U');
		 }
	}

struct symbol *lookup(p,def) char *p; int def;
{ register struct symbol *ptr, *l, *n;
  register int d, sz, deep = 0;
	ptr = symtab;
	while(ptr != (struct symbol *)NULL ) {
		if((d=strcmp(ptr->name,p))==0) break;
		l = ptr;
		deep++;
		if(d>0) ptr = ptr->llink;
		else    ptr = ptr->rlink;
	}
	if(ptr != (struct symbol *)NULL) return(ptr);
	if(pass==2) error('U');
	if((n = (struct symbol *)malloc(sizeof(struct symbol)))== 
		(struct symbol *)NULL)
		fatal("out of space",(char *)NULL);
	stor += sizeof(struct symbol);
	if(deep > depth) depth = deep;
	n->value = 0;
	n->flag = N_UNDF;
	n->other = 0;
	n->desc = 0;
	n->llink = (struct symbol *)NULL;
	n->rlink = (struct symbol *)NULL;
	if(symtab == (struct symbol *)NULL) {symtab=n;}
	else {
		if(d>0) l->llink = n;
		else    l->rlink = n;
		}
	sz = strlen(p);
	if((n->name = (char *)malloc(d=sz+1))== (char *)NULL)
		fatal("out of space",(char *)NULL);
	stor += d;
	strcpy(n->name,p);
	if(def==DEF) {
		if(p[0] != 'L' || lflag) {
			if(globall==(struct symbol *)NULL) globall=n;
			else			globaln->next = n;
			n->index = symsize++;
#ifdef FLEXNAMES
			n->sindex = csindex;
			csindex += sz+1;
#endif
			n->next = (struct symbol *)NULL;
			globaln = n;
			}
		}
	return(n);
}

makestab(p,type,other,desc,val)
 char *p;
 unsigned int type, desc, other;
 unsigned long val;
{	register struct symbol *n;
	register int sz, d;

	if((n = (struct symbol *)malloc(sizeof(struct symbol)))==
		(struct symbol *) NULL)
		fatal("out of space",(char *)NULL);
	stor += sizeof(struct symbol);
	n->name = (char *)NULL;
	n->value = val;
	n->flag = type;
	n->other = other;
	n->desc = desc;
	n->llink = NULL;
	n->rlink = NULL;
	sz = (p==(char *)NULL)? 0: strlen(p);
	if(globall==(struct symbol *)NULL)	globall=n;
	else			globaln->next = n;
	n->index = symsize++;
#ifdef FLEXNAMES
	n->sindex = (p==(char *)NULL) ? 0: csindex;
	csindex += (p==(char *)NULL) ? 0 : (sz+1);
#endif
	n->next = (struct symbol *)NULL;
	globaln = n;
	if(p!= (char *)NULL) {
		if((n->name = (char *)malloc(d=sz+1))== NULL)
			fatal("out of space",(char *)NULL);
		stor += d;
		strcpy(n->name,p);
	}
}

printsym() {
	set(stitle,"  Symbol Table");
	pgline = 0;
	prline[0] = '\n';
	prline[1] = '\0';
	printit();
	printit();
	position = 0;
	traverse();
	printit();
}

void
traverse()
{
	struct symbol **stack, **stkptr, *p;
	register int i;

	if((stack =
	     (struct symbol **)malloc(depth*sizeof(struct symbol *))) == NULL)
		fatal("Out of memory",(char *)NULL);
	stkptr = stack;
	*stkptr++ = (struct symbol *)NULL;
	p = symtab;
	do {
		if(p != (struct symbol *)NULL) {
			*stkptr++ = p;
			p = p->llink;
		} else {
			p = *--stkptr;
			if(p == (struct symbol *)NULL) {
				free(stack);
				return;
			}
			if((p->flag&N_TYPE) != REG) {
				for(i=0; i<NCPS; i++) {
					if(p->name[i] == '\0') break;
					prline[position++] = p->name[i];
				}
				for(; i<NCPS; i++) {
					prline[position++] = ' ';
				}
				prline[position++] = ' ';
				prline[position++] = '=';
				prline[position++] = ' ';
				prcol = position;
				fillloc(p->value,ADDRSZ);
				position+=ADDRSZ;
				prline[position++] = relcode(p->flag);
				prline[position++] = ' ';
				if(position > 72) {
					prline[position++] = '\n';
					prline[position++] = '\0';
					printit();
					position = 0;
				}
				prline[position] = '\0';
			}
			p = p->rlink;
		}
	} while(1);
}

dosym() {
register struct symbol *p;
struct nlist x;
register int i;

#ifdef MINIX_OBJ
#ifdef FLEXNAMES
	/* output string table size */
	putl((long)csindex,output);
#endif
#endif
	/* output symbol table */
	for(p=globall; p != (struct symbol *)NULL; p= p->next) {
#ifdef MINIX_OBJ
#ifdef FLEXNAMES
		putl(p->sindex,output);		/* Pointer to symbol */
#else	/* FLEXNAMES */
		for(i=0; i<NCPS; i++) putc(p->name[i],output);
#endif  /* FLEXNAMES */
		putl(p->value,output);		/* value */
		putc((char)p->flag,output);	/* storage class */
		putc(p->other,output);		/* # aux entries */
		putwd(p->desc,output);		/* type */
#else   /* MINIX_OBJ */
#ifdef FLEXNAMES
		putl(p->sindex,output);
		putc(p->flag, output);
		putc(p->other,output);
		putwd(p->desc, output);
		putl(p->value, output);
#else
		for(i=0; i<NCPS; i++) putc(p->name[i],output);
		putwd(p->flag,output);
		putl(p->value,output);
#endif /* FLEXNAMES */
#endif /* MINIX_OBJ */ 
		}
#ifdef FLEXNAMES
#ifndef MINIX_OBJ
	/* now the string table */
	putl((long)csindex,output);
#endif
	for(p=globall; p != (struct symbol *)NULL; p=p->next) {
		if(p->name == (char *)NULL) continue;
		fputs(p->name, output);
		putc('\0',output);
		}
#endif
	}

void
fixsym()
{
	struct symbol **stack, **stkptr, *p;

	if((stack =
	  (struct symbol **)malloc(depth*sizeof(struct symbol *))) ==
			(struct symbol **)NULL)
		fatal("Out of memory",(char *)NULL);
	stkptr = stack;
	*stkptr++ = (struct symbol *)NULL;
	p = symtab;
	do {
		if(p != (struct symbol *)NULL) {
			*stkptr++ = p;
			p = p->llink;
		} else {
			p = *--stkptr;
			if(p == (struct symbol *)NULL) {
				free(stack);
				break;
			}
			if(uflag && p->flag==N_UNDF) {
				p->value = 0;
				p->flag = N_EXT|N_UNDF;
			}
			if((p->flag&N_TYPE) == N_DATA) {
				p->value += loc[N_TEXT];
			}
			else if((p->flag&N_TYPE) == N_BSS) {
				p->value += loc[N_TEXT]+loc[N_DATA];
			}
			p = p->rlink;
		}
	} while(1);
}

initsym() {
	register struct opcodes *p;

	for(p=reglist; p->opc ; p++) {
		enter(p->opc, (long)p->type, (int)p->base);
		}
	globall = (struct symbol *)NULL;    /* remove registers from list */
#ifdef FLEXNAMES
	csindex = 4;
#endif
	symsize = 0L;
}

/* Travers the symbol table and add change to any text symbol that is
   defined after "after" */
void
adjust(after, change, sec)
long int after, change, sec;
{
	struct symbol **stack, **stkptr, *p;
	register int i;

	if((stack =
	     (struct symbol **)malloc(depth*sizeof(struct symbol *))) == NULL)
		fatal("Out of memory",(char *)NULL);
	stkptr = stack;
	*stkptr++ = (struct symbol *)NULL;
	p = symtab;
	loc[N_DATA] += change;
	do {
		if(p != (struct symbol *)NULL) {
			*stkptr++ = p;
			p = p->llink;
		} else {
			p = *--stkptr;
			if(p == (struct symbol *)NULL) {
				free(stack);
				return;
			}
			if(p->value >= after && (p->flag&N_TYPE) == sec)
				p->value += change;
			p = p->rlink;
		}
	} while(1);
}

/* Add an variable size instruction to the chain. */
void
addchain(loc, sym, flag, size, extra)
long int loc;
struct symbol *sym;
int flag, size, extra;
{
	struct shortop *p;

	if((p = (struct shortop *)malloc(sizeof(struct shortop)))== 
		(struct shortop *)NULL)
		fatal("out of space",(char *)NULL);
	stor += sizeof(struct shortop);
	p->loc = loc;
	p->sym = sym;
	p->flags = flag;
	p->size = size;
	p->extra = extra;
	p->next = NULL;
	if(opchain == NULL) {
		opchain = p;
	} else {
		nxtop->next = p;
	}
	nxtop = p;
}

/* Convert short opcodes into long opcodes. */
/* Basicly we need to make several passes over the opchain structure until
 * there is no change in any size. At each point in the chain we update the
 * location with the current offset, and call instsize to find out the new size
 * of the opcode. If there is a change we call adjust with the change and
 * update are current offset.
 */
void
fixops()
{
	struct shortop *p;
	int offset[N_TYPE], nsize, again = 1, i;

	/* Fix location based on section */
	for(p = opchain; p != NULL; p = p->next) {
		if((p->flags&N_TYPE) == N_DATA) {
			p->loc += loc[N_TEXT];
		}
		else if((p->flags&N_TYPE) == N_BSS) {
			p->loc += loc[N_TEXT]+loc[N_DATA];
		}
	}
			
	while(again) {
		again = 0;
		for(i=0; i<N_TYPE; offset[i++] = 0);
		for(p = opchain; p != NULL; p = p->next) {
#if 0
			printf("loc = %x -> %x, flag = %x, size = %d, extra = %x ",
				p->loc, p->loc + offset[p->flags&N_TYPE],
				p->flags, p->size, p->extra);
			if(p->sym != 0 && p->sym->name != NULL)
				printf("sym = %s value %x ", p->sym->name,
					p->sym->value);
#endif
			p->loc = p->loc + offset[p->flags&N_TYPE];
			if(p->flags & XALIGN) 
				for(nsize=0; (p->loc+nsize)&p->extra; nsize++);
			else 
				nsize = instsize(p);
			if(nsize != p->size) {
#if 0
				printf("new size %d\n", nsize);
#endif
				adjust((p->flags & XALIGN) ? p->loc:(p->loc+1),
					nsize - p->size, p->flags&N_TYPE);
				offset[p->flags&N_TYPE] += nsize - p->size;
				p->size = nsize;
				again = 1;
			} 
#if 0
			else	printf("\n");
#endif
		}
		/* Fix up the size of the segments */
		for(i=0; i<N_TYPE; i++)
			loc[i] += offset[i];
	}
}

#ifdef MAXCOND
int defed(p) char *p;
{ register struct symbol *ptr, *l, *n;
  register int d;

	ptr = symtab;
	while(ptr != (struct symbol *)NULL ) {
		if((d=strcmp(ptr->name,p))==0) break;
		l = ptr;
		if(d<0) ptr = ptr->llink;
		else    ptr = ptr->rlink;
	}
	if(ptr != (struct symbol *)NULL) return((ptr->flag&N_ETYP)!=N_UNDF);
	return(0);
}
#endif
